#ifndef PHYSIKEINGABE_H
#define PHYSIKEINGABE_H

#include<SysUtils.hpp>
#include<controls.hpp>
#include<Classes.hpp>
#include<Forms.hpp>
#include "PhysikCombo_II.h"
#include "cdblspin.h"
#include "UserEditor.h"

class EInvalidEinheit:public Exception{
 public:
   EInvalidEinheit( const String Msg ) :
   Exception(Msg){}
};


class PACKAGE KPhysikEingabe : public TWinControl
{
 friend class KUserEditor;

private:
  KUserValues* FUserWerte;
  KString* FStringUserWerte;
  KPhysikCombo_II* FComboPhysik;     // nicht TComboPhysik
  TCDoubleSpinEdit* FDblSpin;
  bool FSofortUmrechnen;
  bool  FCombo_Visible;
  bool  FEdit_Visible;
  double FSIWert;
  double SIIncrement;
  Einheit FEinheiten;
  bool FReadOnly;
  double FRatio;
  double FFocusValue;
  int FFocusItem;
  TNotifyEvent FOnEntering;
  TNotifyEvent FOnExiting;
  TNotifyEvent FOnChange;
  TNotifyEvent FOnChanged;
  TNotifyEvent FOnTastenDruck;
  TKeyPressEvent FOnKeyPress;
  double value_on_focus;

//  void __fastcall SetUserWerte(KUserValues* uservalue);
  void __fastcall SetUserWerte(KString* val);
  void __fastcall SetIncrement(double NewValue);
  double __fastcall GetIncrement(void);
  void __fastcall SetMaxValue(double NewValue);
  double __fastcall GetMaxValue(void);
  void __fastcall SetMinValue(double NewValue);
  double __fastcall GetMinValue(void);
  void __fastcall SetValue(double NewValue);
  double __fastcall GetValue(void);
  Einheit __fastcall GetEinheiten(void);
  void __fastcall SetEinheiten(Einheit aEinheit);
  AnsiString __fastcall GetEEinheit(void);
  void __fastcall SetEEinheit(AnsiString aString);
  double __fastcall CheckValue(double NewValue);
  void __fastcall SetReadOnly(bool NewValue);
  bool __fastcall GetReadOnly(void);
  void __fastcall SetRatio(double ratio);
 MESSAGE void __fastcall CMEnter(TWMNoParams &Message);
 MESSAGE void __fastcall CMExit(TWMNoParams &Message);

 //MESSAGE void __fastcall WMKeyDown(TWMNoParams &Message);
protected:
  virtual void __fastcall CreateWnd();
  virtual void  DoEntering();
  virtual void DoExiting();
  virtual void DoChange();
  virtual void DoChanged();
  void __fastcall TastenDruck(TObject* Sender);
  void __fastcall KeyPress(TObject* Sender, Char& Key);
  void __fastcall ComboChange(TObject* Sender);
  void __fastcall SpinEditChange(TObject* Sender);
  void __fastcall EscPress(TObject* Sender);
  void __fastcall CheckEsc(TObject *Sender, WORD &Key,
      TShiftState Shift);
 // bool __fastcall DoKeyDown(TWMKey &Message);
 // DYNAMIC void __fastcall KeyDown(Word &Key,  TShiftState Shift);
  void __fastcall WMSize(TWMSize &Message);


public:
  __fastcall KPhysikEingabe(TComponent* Owner);
  TRect GCR(void);
  void __fastcall SetzeSIWert(double NewValue);
  void __fastcall Benutzer_Einheit(AnsiString SI_Einheit);
  void __fastcall Benutzer_Einheit_Hinzu(AnsiString Einheit, double Umrechnung);
  void __fastcall Hide_Combo(bool t);
  void __fastcall Hide_Edit(bool t);

__published:
  /* hier mssen Funktionen rein: beim nder Einheit auf User_defined
  setzen,etc*/
  __property KString* UserWerte={read=FStringUserWerte,write=SetUserWerte};
  __property TabOrder;
  __property TabStop;
 // __property KUserValues UserEinheiten;
  __property bool SofortUmrechnen={read=FSofortUmrechnen ,write=FSofortUmrechnen};
  __property double Increment={read=GetIncrement,write=SetIncrement};
  __property double MaxValue={read=GetMaxValue,write=SetMaxValue};
  __property double MinValue={read=GetMinValue,write=SetMinValue};
  __property double Value={read=GetValue,write=SetValue};
  __property double SIWert={read=FSIWert};
  __property bool ReadOnly={read=GetReadOnly,write=SetReadOnly};
  __property Einheit Einheiten={read=GetEinheiten,write=SetEinheiten};
  __property AnsiString EingestellteEinheit={read=GetEEinheit,write=SetEEinheit};
  __property double Ratio={read=FRatio,write=SetRatio};
  __property bool  Combo_Visible={read=FCombo_Visible,write=Hide_Combo,default=1};
  __property bool  Edit_Visible={read=FEdit_Visible,write=Hide_Edit,default=1};
     

   // PROP_PUBLISHED(KUserValues*,Test,nodefault);

  __property TNotifyEvent OnEntering = {read = FOnEntering , write = FOnEntering};
  __property TNotifyEvent OnExiting = {read = FOnExiting , write = FOnExiting};
  __property TNotifyEvent OnChange = {read = FOnChange , write = FOnChange};
  __property TNotifyEvent OnTastenDruck = {read =FOnTastenDruck , write = FOnTastenDruck};
  __property TNotifyEvent OnChanged = {read = FOnChanged , write = FOnChanged};
  __property TKeyPressEvent OnKeyPress = {read = FOnKeyPress ,
                                          write = FOnKeyPress};
BEGIN_MESSAGE_MAP
   VCL_MESSAGE_HANDLER(CM_ENTER, TWMNoParams, CMEnter)
   VCL_MESSAGE_HANDLER(CM_EXIT, TWMNoParams, CMExit)
  	MESSAGE_HANDLER(WM_SIZE, TWMSize, WMSize)

 //  VCL_MESSAGE_HANDLER(WM_KEYDOWN, TWMNoParams, WMKeyDown);
END_MESSAGE_MAP(TWinControl)
};



#endif


